#include "firewallimpl.h"
#include <qlistbox.h>
#include <qmessagebox.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qinputdialog.h>

firewallimpl::firewallimpl(QWidget *parent, const char *name ) : firewall(parent,name) {
cargalista();
}


firewallimpl::~firewallimpl(){
}

void firewallimpl::bEliminar(){
     if (lreglas->currentText()!=""){
	switch( QMessageBox::warning( this, "Confimacion","Desea eliminar la regla:\n\n" + lreglas->currentText(), "No (Cancelar)", "Si (Aceptar)", 0, 0, 1 )){
  case 0: // No escribir
  					//
      break;
  case 1: // Escribir
     system("iptables -D " + lreglas->currentText());
     lreglas->removeItem(lreglas->currentItem());
     cargalista();
     break;
  }

}
}
void firewallimpl::bAgregar(){

bool ok = FALSE;
QString text = QInputDialog::getText(
                    tr( "Ingreso de Dato" ),
                    tr( "Ingrese la regla\nEjemplo: INPUT -s 65.54.226.254 -j DROP\n\niptables -A" ),
                    QLineEdit::Normal, QString::null, &ok, this );
  if ( ok && !text.isEmpty() ){
     system("iptables -A" + text);
     lreglas->insertItem(text);
     cargalista();
  }
}

void firewallimpl::bBloquearIp(){
     bool ok = FALSE;
QString text = QInputDialog::getText(
                    tr( "Ingreso de Dato" ),
                     tr( "Ingrese el IP a bloquear\nEjemplo: 65.54.226.254\n\nIP?" ),
                    QLineEdit::Normal, QString::null, &ok, this );
  if ( ok && !text.isEmpty() ){
     system("iptables -A INPUT -s " + text + " -j DROP");
     lreglas->insertItem("INPUT -s " + text + " -j DROP");
     cargalista();

  }
}

void firewallimpl::cargalista(){
     lreglas->clear();
     system("iptables-save >/usr/local/share/serviciosinge/firewall");

    QFile f("/usr/local/share/serviciosinge/firewall");
    if ( f.open(IO_ReadOnly) ) {    // file opened successfully
        QTextStream t( &f );        // use a text stream
        QString leelinea;
        while ( !t.eof() ) {        // until end of file...
              leelinea=t.readLine();
              if (leelinea.compare("*filter")==0){
                         //lee los 3 estados
                         leelinea=t.readLine();
                         leelinea=t.readLine();
                         leelinea=t.readLine();
                         // lee los datos
                         leelinea=t.readLine();
                         while(leelinea.compare("COMMIT")!=0){
                              lreglas->insertItem(leelinea.remove( 0, 3 ));
                              leelinea=t.readLine();
                         }
              }
        }
        f.close();
    }
    else{
          // no se pudo abrir el archivo
          QMessageBox:: warning( this, "Error", "No se pudo leer las reglas de Firewall.\n Intente Recargar...");
    }

}
