#include "form1impl.h"
#include "confimpl.h"
#include "firewallimpl.h"
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qfile.h>
#include <qlabel.h>
#include <qtextstream.h>
#include <qtimer.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qapplication.h>
#include <qregexp.h>
#include <qstring.h>
#include <qkeycode.h>


class QToolBar;
class QPopupMenu;

//DECLARO GLOBALES
QString ConfEditor="kwrite";
QString ConfAbrirManual="htmlview file:/usr/local/share/serviciosinge/doc/serviciosinge/index.html";

QString ConfIniciarGate="/etc/rc.d/init.d/inge-gate start";
QString ConfDetenerGate="/etc/rc.d/init.d/inge-gate stop";
QString ConfReiniciarGate="/etc/rc.d/init.d/inge-gate restart";
QString ConfEstadoGate="/var/run/inge-gate.pid";
QString ConfEditarGate="%editor /etc/rc.d/init.d/inge-gate";

QString ConfIniciarSquid="/etc/rc.d/init.d/squid start";
QString ConfDetenerSquid="/etc/rc.d/init.d/squid stop";
QString ConfReiniciarSquid="/etc/rc.d/init.d/squid restart";
QString ConfEstadoSquid="/var/run/squid.pid";
QString ConfEditarSquid="%editor /etc/squid/squid.conf";
QString ConfLogSquid="%editor /var/log/squid/access.log";

QString ConfIniciarHttpd="/etc/rc.d/init.d/httpd start";
QString ConfDetenerHttpd="/etc/rc.d/init.d/httpd stop";
QString ConfReiniciarHttpd="/etc/rc.d/init.d/httpd restart";
QString ConfEstadoHttpd="/var/run/httpd.pid";
QString ConfEditarHttpd="%editor /etc/httpd/conf/httpd.conf";
QString ConfLogHttpd="%editor /var/log/httpd/access_log";

QString ConfIniciarSamba="/etc/rc.d/init.d/smb start";
QString ConfDetenerSamba="/etc/rc.d/init.d/smb stop";
QString ConfReiniciarSamba="/etc/rc.d/init.d/smb restart";
QString ConfEstadoSamba="/var/lock/subsys/smb";
QString ConfEditarSamba="htmlview http://127.0.0.1:901/";
QString ConfLogSamba="kfmclient openProfile filemanagement /var/log/samba";

QString ConfIniciarSendmail="/etc/rc.d/init.d/sendmail start";
QString ConfDetenerSendmail="/etc/rc.d/init.d/sendmail stop";
QString ConfReiniciarSendmail="/etc/rc.d/init.d/sendmail restart";
QString ConfEstadoSendmail="/var/run/sendmail.pid";
QString ConfEditarSendmail="%editor /etc/sendmail.cf";
QString ConfLogSendmail="%editor /var/log/maillog";

QString ConfIniciarDns="/etc/rc.d/init.d/named start";
QString ConfDetenerDns="/etc/rc.d/init.d/named stop";
QString ConfReiniciarDns="/etc/rc.d/init.d/named restart";
QString ConfEstadoDns="/var/run/named/named.pid";
QString ConfEditarDns="/usr/bin/bindconf";

QString ConfIniciarXinetd="/etc/rc.d/init.d/xinetd start";
QString ConfDetenerXinetd="/etc/rc.d/init.d/xinetd stop";
QString ConfReiniciarXinetd="/etc/rc.d/init.d/xinetd restart";
QString ConfEstadoXinetd="/var/run/xinetd.pid";
QString ConfEditarXinetd="kfmclient openProfile filemanagement /etc/xinetd.d";
QString ConfLogXinetd="%editor /var/log/secure";

QString ConfDirectorioXinetd="/etc/xinetd.d";
QString ConfEditarFtp="%editor /etc/ftpaccess";
//FIN DE CARGA DE VARIABLES GLOBALES

confimpl::confimpl(QWidget *parent, const char *name ) : conf(parent,name) {
//CARGAR LAS LINE EDIT
LeerEtiquetas();
}

confimpl::~confimpl(){
}

void confimpl::bAplicar_Click(){
    QFile f("/usr/local/share/serviciosinge/conf");
    if ( !f.open( IO_WriteOnly ) ) {
			QMessageBox:: warning( this, "Error", "No se pudo escribir el Archivo");
			return;
    }

//GUARDO EL ARCHIVO DE CONFIGURACION

QString text=cEditor->text() + "\n" + \
cAbrirManual->text() + "\n" + \
cIniciarGate->text() + "\n" + \
cDetenerGate->text() + "\n" + \

cReiniciarGate->text() + "\n" + \
cEstadoGate->text() + "\n" + \
cEditarGate->text() + "\n" + \
cIniciarSquid->text() + "\n" + \
cDetenerSquid->text() + "\n" + \
cReiniciarSquid->text() + "\n" + \
cEstadoSquid->text() + "\n" + \
cEditarSquid->text() + "\n" + \
cLogSquid->text() + "\n" + \
cIniciarHttpd->text() + "\n" + \
cDetenerHttpd->text() + "\n" + \
cReiniciarHttpd->text() + "\n" + \
cEstadoHttpd->text() + "\n" + \
cEditarHttpd->text() + "\n" + \
cLogHttpd->text() + "\n" + \
cIniciarSamba->text() + "\n" + \
cDetenerSamba->text() + "\n" + \
cReiniciarSamba->text() + "\n" + \
cEstadoSamba->text() + "\n" + \
cEditarSamba->text() + "\n" + \
cLogSamba->text() + "\n" + \
cIniciarSendmail->text() + "\n" + \
cDetenerSendmail->text() + "\n" + \
cReiniciarSendmail->text() + "\n" + \
cEstadoSendmail->text() + "\n" + \
cEditarSendmail->text() + "\n" + \
cLogSendmail->text() + "\n" + \
cIniciarDns->text() + "\n" + \
cDetenerDns->text() + "\n" + \
cReiniciarDns->text() + "\n" + \
cEstadoDns->text() + "\n" + \
cEditarDns->text() + "\n" + \
cIniciarXinetd->text() + "\n" + \
cDetenerXinetd->text() + "\n" + \
cReiniciarXinetd->text() + "\n" + \
cEstadoXinetd->text() + "\n" + \
cEditarXinetd->text() + "\n" + \
cLogXinetd->text() + "\n" + \
cDirectorioXinetd->text() + "\n" + \
cEditarFtp->text() + "\n";

    QTextStream t( &f );
  	t << text;
    f.close();
//GUARDO EN LAS VARIABLES GLOBALES

ConfEditor=cEditor->text();
ConfAbrirManual=cAbrirManual->text();
ConfIniciarGate=cIniciarGate->text();
ConfDetenerGate=cDetenerGate->text();
ConfReiniciarGate=cReiniciarGate->text();
ConfEstadoGate=cEstadoGate->text();
ConfEditarGate=cEditarGate->text();
ConfIniciarSquid=cIniciarSquid->text();
ConfDetenerSquid=cDetenerSquid->text();
ConfReiniciarSquid=cReiniciarSquid->text();
ConfEstadoSquid=cEstadoSquid->text();
ConfEditarSquid=cEditarSquid->text();
ConfLogSquid=cLogSquid->text();
ConfIniciarHttpd=cIniciarHttpd->text();
ConfDetenerHttpd=cDetenerHttpd->text();
ConfReiniciarHttpd=cReiniciarHttpd->text();
ConfEstadoHttpd=cEstadoHttpd->text();
ConfEditarHttpd=cEditarHttpd->text();
ConfLogHttpd=cLogHttpd->text();
ConfIniciarSamba=cIniciarSamba->text();
ConfDetenerSamba=cDetenerSamba->text();
ConfReiniciarSamba=cReiniciarSamba->text();
ConfEstadoSamba=cEstadoSamba->text();
ConfEditarSamba=cEditarSamba->text();
ConfLogSamba=cLogSamba->text();
ConfIniciarSendmail=cIniciarSendmail->text();
ConfDetenerSendmail=cDetenerSendmail->text();
ConfReiniciarSendmail=cReiniciarSendmail->text();
ConfEstadoSendmail=cEstadoSendmail->text();
ConfEditarSendmail=cEditarSendmail->text();
ConfLogSendmail=cLogSendmail->text();
ConfIniciarDns=cIniciarDns->text();
ConfDetenerDns=cDetenerDns->text();
ConfReiniciarDns=cReiniciarDns->text();
ConfEstadoDns=cEstadoDns->text();
ConfEditarDns=cEditarDns->text();
ConfIniciarXinetd=cIniciarXinetd->text();
ConfDetenerXinetd=cDetenerXinetd->text();
ConfReiniciarXinetd=cReiniciarXinetd->text();
ConfEstadoXinetd=cEstadoXinetd->text();
ConfEditarXinetd=cEditarXinetd->text();
ConfLogXinetd=cLogXinetd->text();
ConfDirectorioXinetd=cDirectorioXinetd->text();
ConfEditarFtp=cEditarFtp->text();

}

void confimpl::bCancelar_Click(){}
void confimpl::bPordefecto_Click(){
ConfPorDefecto();
}
void confimpl::LeerEtiquetas(){

cEditor->setText(ConfEditor);
cAbrirManual->setText(ConfAbrirManual);
cIniciarGate->setText(ConfIniciarGate);
cDetenerGate->setText(ConfDetenerGate);
cReiniciarGate->setText(ConfReiniciarGate);
cEstadoGate->setText(ConfEstadoGate);
cEditarGate->setText(ConfEditarGate);
cIniciarSquid->setText(ConfIniciarSquid);
cDetenerSquid->setText(ConfDetenerSquid);
cReiniciarSquid->setText(ConfReiniciarSquid);
cEstadoSquid->setText(ConfEstadoSquid);
cEditarSquid->setText(ConfEditarSquid);
cLogSquid->setText(ConfLogSquid);
cIniciarHttpd->setText(ConfIniciarHttpd);
cDetenerHttpd->setText(ConfDetenerHttpd);
cReiniciarHttpd->setText(ConfReiniciarHttpd);
cEstadoHttpd->setText(ConfEstadoHttpd);
cEditarHttpd->setText(ConfEditarHttpd);
cLogHttpd->setText(ConfLogHttpd);
cIniciarSamba->setText(ConfIniciarSamba);
cDetenerSamba->setText(ConfDetenerSamba);
cReiniciarSamba->setText(ConfReiniciarSamba);
cEstadoSamba->setText(ConfEstadoSamba);
cEditarSamba->setText(ConfEditarSamba);
cLogSamba->setText(ConfLogSamba);
cIniciarSendmail->setText(ConfIniciarSendmail);
cDetenerSendmail->setText(ConfDetenerSendmail);
cReiniciarSendmail->setText(ConfReiniciarSendmail);
cEstadoSendmail->setText(ConfEstadoSendmail);
cEditarSendmail->setText(ConfEditarSendmail);
cLogSendmail->setText(ConfLogSendmail);
cIniciarDns->setText(ConfIniciarDns);
cDetenerDns->setText(ConfDetenerDns);
cReiniciarDns->setText(ConfReiniciarDns);
cEstadoDns->setText(ConfEstadoDns);
cEditarDns->setText(ConfEditarDns);
cIniciarXinetd->setText(ConfIniciarXinetd);
cDetenerXinetd->setText(ConfDetenerXinetd);
cReiniciarXinetd->setText(ConfReiniciarXinetd);
cEstadoXinetd->setText(ConfEstadoXinetd);
cEditarXinetd->setText(ConfEditarXinetd);
cLogXinetd->setText(ConfLogXinetd);
cDirectorioXinetd->setText(ConfDirectorioXinetd);
cEditarFtp->setText(ConfEditarFtp);

}

//TERMINAN LAS FUNCIONES DE CONF IMPL


form1::form1( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : form1Base( parent, name, modal, fl )
{
//QMessageBox:: warning( this, "Constructor", " ");


//Leo Archivo de Configuracion
QFile f("/usr/local/share/serviciosinge/conf");
if (f.exists()) {
    if ( f.open(IO_ReadOnly) ) {    // file opened successfully

        QTextStream t( &f );        // use a text stream
        QString s;

// CARGO LAS VARIABLES
s = t.readLine();
ConfEditor=s;
s = t.readLine();
ConfAbrirManual=s;

s = t.readLine();
ConfIniciarGate=s;
s = t.readLine();
ConfDetenerGate=s;
s = t.readLine();
ConfReiniciarGate=s;
s = t.readLine();
ConfEstadoGate=s;
s = t.readLine();
ConfEditarGate=s;

s = t.readLine();
ConfIniciarSquid=s;
s = t.readLine();
ConfDetenerSquid=s;
s = t.readLine();
ConfReiniciarSquid=s;
s = t.readLine();
ConfEstadoSquid=s;
s = t.readLine();
ConfEditarSquid=s;
s = t.readLine();
ConfLogSquid=s;

s = t.readLine();
ConfIniciarHttpd=s;
s = t.readLine();
ConfDetenerHttpd=s;
s = t.readLine();
ConfReiniciarHttpd=s;
s = t.readLine();
ConfEstadoHttpd=s;
s = t.readLine();
ConfEditarHttpd=s;
s = t.readLine();
ConfLogHttpd=s;

s = t.readLine();
ConfIniciarSamba=s;
s = t.readLine();
ConfDetenerSamba=s;
s = t.readLine();
ConfReiniciarSamba=s;
s = t.readLine();
ConfEstadoSamba=s;
s = t.readLine();
ConfEditarSamba=s;
s = t.readLine();
ConfLogSamba=s;

s = t.readLine();
ConfIniciarSendmail=s;
s = t.readLine();
ConfDetenerSendmail=s;
s = t.readLine();
ConfReiniciarSendmail=s;
s = t.readLine();
ConfEstadoSendmail=s;
s = t.readLine();
ConfEditarSendmail=s;
s = t.readLine();
ConfLogSendmail=s;

s = t.readLine();
ConfIniciarDns=s;
s = t.readLine();
ConfDetenerDns=s;
s = t.readLine();
ConfReiniciarDns=s;
s = t.readLine();
ConfEstadoDns=s;
s = t.readLine();
ConfEditarDns=s;


s = t.readLine();
ConfIniciarXinetd=s;
s = t.readLine();
ConfDetenerXinetd=s;
s = t.readLine();
ConfReiniciarXinetd=s;
s = t.readLine();
ConfEstadoXinetd=s;
s = t.readLine();
ConfEditarXinetd=s;
s = t.readLine();
ConfLogXinetd=s;

s = t.readLine();
ConfDirectorioXinetd=s;
s = t.readLine();
ConfEditarFtp=s;

  	    f.close();
    }
    else{
		// no se pudo abrir el archivo
					QMessageBox:: warning( this, "Error", "No se puede Leer el Archivo de Configuracion");
		}
}
else{
//Se ejecuta por primera vez el programa
	switch( QMessageBox::warning( this, "Bienvenido a Servicios de Red by iNGENI{} 1.0","Por primera vez se ejecuta el programa\n\n"
	"Desea escribir el archivo /etc/hosts.deny ?\n"
	"(Se agrega la linea ALL:ALL) por defecto.\n"
	"Esto permitira optimizar el uso de xinetd \n"
	"y loguear los accesos no autorizados al sistema.\n"
	"--- Se creara una copia de seguridad de su archivo original\n"
	"en /etc/hosts.deny.viejo ---\n", "No Escribir(Cancelar)", "Escribir (Recomendado)", 0, 0, 1 )){
  case 0: // No escribir
					//
      break;
  case 1: // Escribir
			EscribirHostsDeny();
      break;
  }
//Se crea el fichero de configuracion por primera vez
    QFile f("/usr/local/share/serviciosinge/conf");
    if ( !f.open( IO_WriteOnly ) ) {
			QMessageBox:: warning( this, "Error", "No se pudo escribir el Archivo");
			return;
    }
		QString text= ConfEditor + "\n" + ConfAbrirManual + "\n" + \
		ConfIniciarGate + "\n" + ConfDetenerGate + "\n" + \
		ConfReiniciarGate + "\n" + ConfEstadoGate + "\n" + \
		ConfEditarGate + "\n" + ConfIniciarSquid + "\n" + \
		ConfDetenerSquid + "\n" + ConfReiniciarSquid + "\n" + \
		ConfEstadoSquid + "\n" + ConfEditarSquid + "\n" + \
		ConfLogSquid + "\n" + ConfIniciarHttpd + "\n" + \
		ConfDetenerHttpd + "\n" + ConfReiniciarHttpd + "\n" + \
		ConfEstadoHttpd + "\n" + ConfEditarHttpd + "\n" + \
		ConfLogHttpd + "\n" + ConfIniciarSamba + "\n" + \
		ConfDetenerSamba + "\n" + ConfReiniciarSamba + "\n" + \
		ConfEstadoSamba + "\n" + ConfEditarSamba + "\n" + \
		ConfLogSamba  + "\n" +ConfIniciarSendmail + "\n" + \
		ConfDetenerSendmail + "\n" + ConfReiniciarSendmail + "\n" + \
		ConfEstadoSendmail + "\n" + ConfEditarSendmail + "\n" + \
		ConfLogSendmail + "\n" + ConfIniciarDns + "\n" + \
		ConfDetenerDns + "\n" + ConfReiniciarDns + "\n" + \
		ConfEstadoDns + "\n" + ConfEditarDns + "\n" + \
		ConfIniciarXinetd + "\n" + ConfDetenerXinetd + "\n" + \
		ConfReiniciarXinetd + "\n" + ConfEstadoXinetd + "\n" + \
		ConfEditarXinetd + "\n" + ConfLogXinetd + "\n" + \
		ConfDirectorioXinetd + "\n" + ConfEditarFtp + "\n";

    QTextStream t( &f );
	  t << text;

    f.close();

//TERMINA LA ESCRITURA POR PRIMERA VEZ
}


//Leo todos los Estados
LeerEstadoGate();
LeerEstadoSquid();
LeerEstadoHttpd();
LeerEstadoXinetd();
LeerEstadoTelnet();
LeerEstadoFtp();
LeerEstadoHostsAllow();
LeerEstadoPop3();
LeerEstadoSwat();
LeerEstadoSendmail();
LeerEstadoSamba();
LeerEstadoDns();


//Cargo el Menu

QMenuBar *menuBar;
menuBar = new QMenuBar( this );

QPopupMenu * mArchivo = new QPopupMenu( this );
menuBar->insertItem( "&Archivo", mArchivo );
mArchivo->insertItem( "Crear /etc/hosts.deny Por Defecto", this, SLOT(EscribirHostsDeny()));
mArchivo->insertItem( "Crear /etc/hosts.allow Por Defecto", this, SLOT(EscribirHostsAllow()));
mArchivo->insertSeparator();
mArchivo->insertItem( "Crear inge-gate Por Defecto", this, SLOT(EscribirIngegate()));
mArchivo->insertItem( "Crear /etc/ftpaccess Por Defecto", this, SLOT(EscribirFtp()));
mArchivo->insertSeparator();
mArchivo->insertItem( "Configurar ...", this, SLOT(Configuracion()));
mArchivo->insertSeparator();
mArchivo->insertItem( "S&alir",  qApp, SLOT(quit()), CTRL+Key_Q );


QPopupMenu * mServicios = new QPopupMenu( this );
menuBar->insertItem( "&Servicios", mServicios );

QPopupMenu *mGate = new QPopupMenu( this );
CHECK_PTR( mGate );
mGate->insertItem( "Iniciar", this, SLOT(bIniciarGate_Click()) );
mGate->insertItem( "Detener", this, SLOT(bDetenerGate_Click()) );


mGate->insertItem( "Reiniciar", this, SLOT(bReiniciarGate_Click()) );
mGate->insertSeparator();
mGate->insertItem( "Editar", this, SLOT(bEditarGate_Click()) );
mServicios->insertItem( "Inge-&Gate", mGate );

QPopupMenu *mSquid = new QPopupMenu( this );
CHECK_PTR( mSquid );
mSquid->insertItem( "Iniciar", this, SLOT(bIniciarSquid_Click()) );
mSquid->insertItem( "Detener", this, SLOT(bDetenerSquid_Click()) );
mSquid->insertItem( "Reiniciar", this, SLOT(bReiniciarSquid_Click()) );
mSquid->insertSeparator();
mSquid->insertItem( "Editar", this, SLOT(bEditarSquid_Click()) );
mSquid->insertItem( "Logs", this, SLOT(bLogSquid_Click()) );
mServicios->insertItem( "Squid", mSquid );

QPopupMenu *mHttpd = new QPopupMenu( this );
CHECK_PTR( mHttpd );
mHttpd->insertItem( "Iniciar", this, SLOT(bIniciarHttpd_Click()) );
mHttpd->insertItem( "Detener", this, SLOT(bDetenerHttpd_Click()) );
mHttpd->insertItem( "Reiniciar", this, SLOT(bReiniciarHttpd_Click()) );
mHttpd->insertSeparator();
mHttpd->insertItem( "Editar", this, SLOT(bEditarHttpd_Click()) );
mHttpd->insertItem( "Logs", this, SLOT(bLogHttpd_Click()) );
mServicios->insertItem( "Httpd", mHttpd);

QPopupMenu *mSamba = new QPopupMenu( this );
CHECK_PTR( mSamba );
mSamba->insertItem( "Iniciar", this, SLOT(bIniciarSamba_Click()) );
mSamba->insertItem( "Detener", this, SLOT(bDetenerSamba_Click()) );
mSamba->insertItem( "Reiniciar", this, SLOT(bReiniciarSamba_Click()) );
mSamba->insertSeparator();
mSamba->insertItem( "Editar", this, SLOT(bEditarSamba_Click()) );
mSamba->insertItem( "Logs", this, SLOT(bLogSamba_Click()) );
mServicios->insertItem( "Samba", mSamba);

QPopupMenu *mSendmail = new QPopupMenu( this );
CHECK_PTR( mSendmail );
mSendmail->insertItem( "Iniciar", this, SLOT(bIniciarSendmail_Click()) );
mSendmail->insertItem( "Detener", this, SLOT(bDetenerSendmail_Click()) );
mSendmail->insertItem( "Reiniciar", this, SLOT(bReiniciarSendmail_Click()) );
mSendmail->insertSeparator();
mSendmail->insertItem( "Editar", this, SLOT(bEditarSendmail_Click()) );
mSendmail->insertItem( "Logs", this, SLOT(bLogSendmail_Click()) );
mServicios->insertItem( "Sendmail", mSendmail);

QPopupMenu *mDns = new QPopupMenu( this );
CHECK_PTR( mDns );
mDns->insertItem( "Iniciar", this, SLOT(bIniciarDns_Click()) );
mDns->insertItem( "Detener", this, SLOT(bDetenerDns_Click()) );
mDns->insertItem( "Reiniciar", this, SLOT(bReiniciarDns_Click()) );
mDns->insertSeparator();
mDns->insertItem( "Editar", this, SLOT(bEditarDns_Click()) );
mServicios->insertItem( "Dns", mDns);

QPopupMenu *mXinetd = new QPopupMenu( this );
CHECK_PTR( mXinetd );
mXinetd->insertItem( "Iniciar", this, SLOT(bIniciarXinetd_Click()) );
mXinetd->insertItem( "Detener", this, SLOT(bDetenerXinetd_Click()) );
mXinetd->insertItem( "Reiniciar", this, SLOT(bReiniciarXinetd_Click()) );
mXinetd->insertSeparator();
mXinetd->insertItem( "Editar", this, SLOT(bEditarXinetd_Click()) );
mXinetd->insertItem( "Logs", this, SLOT(bLogXinetd_Click()) );
mServicios->insertItem( "Xinetd", mXinetd);



QPopupMenu * mSXinetd = new QPopupMenu( this );
menuBar->insertItem( "&Xinetd Serv", mSXinetd);

		QPopupMenu *mTelnet = new QPopupMenu( this );
		CHECK_PTR( mTelnet );
		mTelnet->insertItem( "Iniciar", this, SLOT(bIniciarTelnet_Click()) );
		mTelnet->insertItem( "Detener", this, SLOT(bDetenerTelnet_Click()) );
		mSXinetd->insertItem( "Telnet", mTelnet);

		QPopupMenu *mFtp = new QPopupMenu( this );
		CHECK_PTR( mFtp );
		mFtp->insertItem( "Iniciar", this, SLOT(bIniciarFtp_Click()) );
		mFtp->insertItem( "Detener", this, SLOT(bDetenerFtp_Click()) );
		mFtp->insertSeparator();
		mFtp->insertItem( "Editar", this, SLOT(bEditarFtp_Click()) );
		mSXinetd->insertItem( "Ftp", mFtp);

		QPopupMenu *mPop3 = new QPopupMenu( this );
		CHECK_PTR( mPop3 );
		mPop3->insertItem( "Iniciar", this, SLOT(bIniciarPop3_Click()) );
		mPop3->insertItem( "Detener", this, SLOT(bDetenerPop3_Click()) );
		mSXinetd->insertItem( "Pop3", mPop3);

		QPopupMenu *mSwat = new QPopupMenu( this );



		CHECK_PTR( mSwat );

		mSwat->insertItem( "Iniciar", this, SLOT(bIniciarSwat_Click()) );
		mSwat->insertItem( "Detener", this, SLOT(bDetenerSwat_Click()) );
		mSXinetd->insertItem( "Swat", mSwat);

QPopupMenu * mAyuda = new QPopupMenu( this );
menuBar->insertItem( "A&yuda", mAyuda );
mAyuda->insertItem( "Manual...", this, SLOT(VerManual()));
mAyuda->insertSeparator();
mAyuda->insertItem( "Acerca de ...", this, SLOT(VerAcercade()));

}
form1::~form1()
{
//QMessageBox:: warning( this, "DEStructor", " de gate");
bAplicarHostsAllow_Click();
}

// Funciones Ordenadas por EVENTO


//INICIAR
void form1::bIniciarGate_Click(){
	system(ConfIniciarGate);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoGate()) );
}
void form1::bIniciarSquid_Click(){
	system(ConfIniciarSquid);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSquid()) );
}
void form1::bIniciarHttpd_Click(){
	system(ConfIniciarHttpd);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoHttpd()) );
	QTimer::singleShot( 5000, this, SLOT(LeerEstadoHttpd()) );
}
void form1::bIniciarSamba_Click(){
	system(ConfIniciarSamba);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSamba()) );
}
void form1::bIniciarSendmail_Click(){
	system(ConfIniciarSendmail);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSendmail()) );
}
void form1::bIniciarDns_Click(){
	system(ConfIniciarDns);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoDns()) );
}
void form1::bIniciarXinetd_Click(){
	system(ConfIniciarXinetd);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoXinetd()) );
}
void form1::bIniciarTelnet_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/telnet",tTelnet,1,SLOT(LeerEstadoTelnet()));}
void form1::bIniciarFtp_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/wu-ftpd",tFtp,1,SLOT(LeerEstadoFtp()));}
void form1::bIniciarPop3_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/ipop3",tPop3,1,SLOT(LeerEstadoPop3()));}
void form1::bIniciarSwat_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/swat",tSwat,1,SLOT(LeerEstadoSwat()));}

void form1::IniciarDetenerXinetd(const char* archivoestado,QLabel *etiqueta,int activar,const char * member){
    QFile f(archivoestado);
    if ( f.open(IO_ReadOnly) ) {    // file opened successfully
        QTextStream t( &f );        // use a text stream
        QString s="",leelinea;				
        while ( !t.eof() ) {        // until end of file...
					leelinea=t.readLine();
					if (activar==1) {
						leelinea.replace( QRegExp("disable.*=.*yes"), "disable\t= no");

					}
					else{
						leelinea.replace( QRegExp("disable.*=.*no"), "disable\t= yes");
					}
  	      s.append(leelinea);
					s.append("\n");
        }
        f.close();
		    if ( f.open(IO_WriteOnly) ) {    // file opened successfully
	        QTextStream tescribe( &f );        // use a text stream
					tescribe << s;
					f.close();				
				}
		    else{
					// no se pudo abrir el archivo
					etiqueta->setText("<b><font color=darkblue>Error");
					return;
				}
				QString estado=tXinetd->text();
				if (estado.compare("<b><font color=darkgreen>ON")==0){			
					bReiniciarXinetd_Click();
				}
				QTimer::singleShot( 1000, this, member );
    }
    else{
			// no se pudo abrir el archivo
			etiqueta->setText("<b><font color=darkblue>Error");
			return;
		}
}

//DETENER
void form1::bDetenerGate_Click(){
	system(ConfDetenerGate);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoGate()) );	
}
void form1::bDetenerSquid_Click(){
	system(ConfDetenerSquid);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSquid()) );
}
void form1::bDetenerHttpd_Click(){

	system(ConfDetenerHttpd);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoHttpd()) );
}
void form1::bDetenerSamba_Click(){
	system(ConfDetenerSamba);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSamba()) );
}
void form1::bDetenerSendmail_Click(){
	system(ConfDetenerSendmail);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSendmail()) );
}
void form1::bDetenerDns_Click(){
	system(ConfDetenerDns);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoDns()) );
}
void form1::bDetenerXinetd_Click(){
	system(ConfDetenerXinetd);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoXinetd()) );
}
void form1::bDetenerTelnet_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/telnet",tTelnet,0,SLOT(LeerEstadoTelnet()));}
void form1::bDetenerFtp_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/wu-ftpd",tFtp,0,SLOT(LeerEstadoFtp()));}
void form1::bDetenerPop3_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/ipop3",tPop3,0,SLOT(LeerEstadoPop3()));}
void form1::bDetenerSwat_Click(){
IniciarDetenerXinetd(ConfDirectorioXinetd + "/swat",tSwat,0,SLOT(LeerEstadoSwat()));}

//REINICIAR
void form1::bReiniciarGate_Click(){
	system(ConfDetenerGate);
	system(ConfIniciarGate);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoGate()) );
}
void form1::bReiniciarSquid_Click(){
	system(ConfReiniciarSquid);	
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSquid()) );
}
void form1::bReiniciarHttpd_Click(){
	system(ConfReiniciarHttpd);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoHttpd()) );
	QTimer::singleShot( 5000, this, SLOT(LeerEstadoHttpd()) );
}
void form1::bReiniciarSamba_Click(){
	system(ConfReiniciarSamba);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSamba()) );
}
void form1::bReiniciarSendmail_Click(){
	system(ConfReiniciarSendmail);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoSendmail()) );
}
void form1::bReiniciarDns_Click(){
	system(ConfReiniciarDns);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoDns()) );

}
void form1::bReiniciarXinetd_Click(){
	tXinetd->setText("<b><font color=darkblue>---");
	system(ConfReiniciarXinetd);
	QTimer::singleShot( 2000, this, SLOT(LeerEstadoXinetd()) );
}

//EDITAR
void form1::bEditarGate_Click(){
QString s=ConfEditarGate;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bEditarSquid_Click(){
QString s=ConfEditarSquid;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}

void form1::bEditarHttpd_Click(){
QString s=ConfEditarHttpd,e=ConfEditor;
s.replace( QRegExp("%editor"), e);
system(s + " &");
}
void form1::bEditarSamba_Click(){

QString estadoxinetd=tXinetd->text(),estadoswat=tSwat->text();

if (estadoxinetd.compare("<b><font color=darkgreen>ON")==0){			
			if (estadoswat.compare("<b><font color=darkgreen>ON")==0){
							QString s=ConfEditarSamba;
							s.replace( QRegExp("%editor"), ConfEditor);
							system(s + " &");
			}
			else{QMessageBox:: warning( this, "Error", "Debe estar iniciado el servicio SWAT");}
}
else {
			QMessageBox:: warning( this, "Error", "Debe estar iniciado el servicio XINETD");
}
}
void form1::bEditarSendmail_Click(){
QString s=ConfEditarSendmail;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bEditarDns_Click(){
QString s=ConfEditarDns;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bEditarXinetd_Click(){
QString s=ConfEditarXinetd;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bEditarFtp_Click(){
QString s=ConfEditarFtp;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}

//LOG
void form1::bLogSquid_Click(){
QString s=ConfLogSquid;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bLogHttpd_Click(){
QString s=ConfLogHttpd;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bLogSamba_Click(){
QString s=ConfLogSamba;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bLogSendmail_Click(){
QString s=ConfLogSendmail;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bLogXinetd_Click(){
QString s=ConfLogXinetd;
s.replace( QRegExp("%editor"), ConfEditor);
system(s + " &");
}
void form1::bLogHostsAllow_Click(){system(ConfEditor + " /var/log/HOSTS.DENY &");}

//LECTURA DE ESTADOS
void form1::LeerEstadoGate(){Estados(ConfEstadoGate,tGate);}
void form1::LeerEstadoSquid(){Estados(ConfEstadoSquid,tSquid);}
void form1::LeerEstadoHttpd(){Estados(ConfEstadoHttpd,tHttpd);}
void form1::LeerEstadoSendmail(){Estados(ConfEstadoSendmail,tSendmail);}
void form1::LeerEstadoSamba(){Estados(ConfEstadoSamba,tSamba);}
void form1::LeerEstadoDns(){Estados(ConfEstadoDns,tDns);}
void form1::LeerEstadoXinetd(){Estados(ConfEstadoXinetd,tXinetd);}
void form1::LeerEstadoTelnet(){EstadosXinetd(ConfDirectorioXinetd + "/telnet",tTelnet);}
void form1::LeerEstadoFtp(){EstadosXinetd(ConfDirectorioXinetd + "/wu-ftpd",tFtp);}
void form1::LeerEstadoPop3(){EstadosXinetd(ConfDirectorioXinetd + "/ipop3",tPop3);}
void form1::LeerEstadoSwat(){EstadosXinetd(ConfDirectorioXinetd + "/swat",tSwat);}

void form1::Estados(const char* archivoestado,QLabel *etiqueta){
    QFile f(archivoestado);
    if (f.exists()) {	etiqueta->setText("<b><font color=darkgreen>ON");	}
    else { etiqueta->setText("<b><font color=red>OFF"); }
}
void form1::EstadosXinetd(const char* archivoestado,QLabel *etiqueta){

    QFile f(archivoestado);

    if ( f.open(IO_ReadOnly) ) {    // file opened successfully
        QTextStream t( &f );        // use a text stream
        QString s,apagado="no";			

        while ( !t.eof() ) {        // until end of file...
	        s = t.readLine();
					if (s.contains("disable")==1){
						if (s.contains("yes")==1) {
								etiqueta->setText("<b><font color=red>OFF");
								apagado="si";
								break;
						}
					}
        }
				if (apagado.compare("no")==0){
						etiqueta->setText("<b><font color=darkgreen>ON");
				}
  	    f.close();
    }
    else{
		// no se pudo abrir el archivo
				etiqueta->setText("<b><font color=darkblue>Error");
		}
}
void form1::LeerEstadoHostsAllow(){
    QFile f("/etc/hosts.allow");
    if ( f.open(IO_ReadOnly) ) {    // file opened successfully
        QTextStream t( &f );        // use a text stream
        QString s;
				mlHostsAllow->clear();
				
        while ( !t.eof() ) {        // until end of file...
	        s = t.readLine();
					mlHostsAllow->append( s );
        }
  	    f.close();
    }
    else{
		// no se pudo abrir el archivo
				mlHostsAllow->setText("<b><font color=darkblue>Error");
		}
}

// APLICAR Y ESCRIBIR
void form1::bAplicarHostsAllow_Click(){
    QString text = mlHostsAllow->text();
		text.append("\n");
		if (!(text.right( 2 ).compare("\n\n")==0)){
			text.append("\n");
		}
    QFile f("/etc/hosts.allow");
    if ( !f.open( IO_WriteOnly ) ) {
			QMessageBox:: warning( this, "Error", "No se pudo escribir el Archivo");

			return;
    }
    QTextStream t( &f );
    t << text;

    f.close();
}
void form1::EscribirHostsDeny(){
system("/bin/cp --force -p /etc/hosts.deny /etc/hosts.deny.viejo &");
QString text = "# Modificado por Servicios by Ingenio\nALL:ALL: spawn (/bin/echo `date` Intento en %d de %c >>/var/log/HOSTS.DENY | /usr/bin/play /usr/local/share/serviciosinge/sounds/attack_detected.wav ) & \n\n";	
    QFile f("/etc/hosts.deny");
    if ( !f.open( IO_WriteOnly ) ) {
			QMessageBox:: warning( this, "Error", "No se pudo escribir el Archivo");

			return;
    }
    QTextStream t( &f );
    t << text;

    f.close();
		QMessageBox:: information( this, "Listo", "Se modifico /etc/hosts.deny");
}
void form1::EscribirHostsAllow(){
QString text = "# Modo de Uso    Servicio : IP\n# Ej  in.ftpd: ALL\n# Ej  ALL: 192.168.0.*\n\nALL: 127.0.0.1\n\n";	

		mlHostsAllow->setText(text);
    QFile f("/etc/hosts.allow");
    if ( !f.open( IO_WriteOnly ) ) {
			QMessageBox:: warning( this, "Error", "No se pudo escribir el Archivo");

			return;
    }
    QTextStream t( &f );

    t << text;

    f.close();
		QMessageBox:: information( this, "Listo", "Se modifico /etc/hosts.allow");
}
void form1::EscribirIngegate(){
system("/bin/cp --force -p /etc/rc.d/init.d/inge-gate /etc/rc.d/init.d/inge-gate.viejo &");
system("/bin/cp --force -p /usr/local/share/serviciosinge/pordefecto/inge-gate /etc/rc.d/init.d/inge-gate &");
}
void form1::EscribirFtp(){
system("/bin/cp --force -p /etc/ftpaccess /etc/ftpaccess.viejo &");
system("/bin/cp --force -p /usr/local/share/serviciosinge/pordefecto/ftpaccess /etc/ftpaccess &");

}
void form1::VerManual(){
system(ConfAbrirManual + " &");
}
void form1::VerAcercade(){

QString mensaje="Servicios de Red by iNGENI{}\n"
"Version 1.5\n\n"
"Pagina WEB: http://move.to/ingenio\n"
"E-Mail: ingenio@uol.com.ar\n\n"

"Colaboradores:\n\n"
"   Mounting-fd\n"
"   Night\n"
"   Qt-man\n"
"   Dreamtheater";
		QMessageBox:: information( this, "Acerca de...", mensaje);
}

void form1::Configuracion()
{
	(new confimpl())->show();
}
void form1::bFirewall_Click()
{
	(new firewallimpl())->show();
}

void confimpl::ConfPorDefecto(){

cEditor->setText("kwrite");
cAbrirManual->setText("htmlview file:/usr/local/share/serviciosinge/doc/serviciosinge/index.html");

cIniciarGate->setText("/etc/rc.d/init.d/inge-gate start");
cDetenerGate->setText("/etc/rc.d/init.d/inge-gate stop");
cReiniciarGate->setText("/etc/rc.d/init.d/inge-gate restart");

cEstadoGate->setText("/var/run/inge-gate.pid");
cEditarGate->setText("%editor /etc/rc.d/init.d/inge-gate");

cIniciarSquid->setText("/etc/rc.d/init.d/squid start");
cDetenerSquid->setText("/etc/rc.d/init.d/squid stop");
cReiniciarSquid->setText("/etc/rc.d/init.d/squid restart");
cEstadoSquid->setText("/var/run/squid.pid");
cEditarSquid->setText("%editor /etc/squid/squid.conf");
cLogSquid->setText("%editor /var/log/squid/access.log");

cIniciarHttpd->setText("/etc/rc.d/init.d/httpd start");
cDetenerHttpd->setText("/etc/rc.d/init.d/httpd stop");
cReiniciarHttpd->setText("/etc/rc.d/init.d/httpd restart");
cEstadoHttpd->setText("/var/run/httpd.pid");
cEditarHttpd->setText("%editor /etc/httpd/conf/httpd.conf");
cLogHttpd->setText("%editor /var/log/httpd/access_log");

cIniciarSamba->setText("/etc/rc.d/init.d/smb start");
cDetenerSamba->setText("/etc/rc.d/init.d/smb stop");
cReiniciarSamba->setText("/etc/rc.d/init.d/smb restart");
cEstadoSamba->setText("/var/lock/subsys/smb");
cEditarSamba->setText("htmlview http://127.0.0.1:901/");
cLogSamba->setText("kfmclient openProfile filemanagement /var/log/samba");

cIniciarSendmail->setText("/etc/rc.d/init.d/sendmail start");
cDetenerSendmail->setText("/etc/rc.d/init.d/sendmail stop");
cReiniciarSendmail->setText("/etc/rc.d/init.d/sendmail restart");
cEstadoSendmail->setText("/var/run/sendmail.pid");
cEditarSendmail->setText("%editor /etc/sendmail.cf");
cLogSendmail->setText("%editor /var/log/maillog");

cIniciarDns->setText("/etc/rc.d/init.d/named start");
cDetenerDns->setText("/etc/rc.d/init.d/named stop");
cReiniciarDns->setText("/etc/rc.d/init.d/named restart");
cEstadoDns->setText("/var/run/named/named.pid");
cEditarDns->setText("/usr/bin/bindconf");

cIniciarXinetd->setText("/etc/rc.d/init.d/xinetd start");
cDetenerXinetd->setText("/etc/rc.d/init.d/xinetd stop");
cReiniciarXinetd->setText("/etc/rc.d/init.d/xinetd restart");
cEstadoXinetd->setText("/var/run/xinetd.pid");
cEditarXinetd->setText("kfmclient openProfile filemanagement /etc/xinetd.d");
cLogXinetd->setText("%editor /var/log/secure");

cDirectorioXinetd->setText("/etc/xinetd.d");
cEditarFtp->setText("%editor /etc/ftpaccess");

}
